Program Learn;

Uses Crt,Dos,Time,INI,TypeText,ProtMenu;

Const
  JoyPort          = $201;
  MaxChannelLength = 256;
  _32BIT_OPERAND   = $66;
  Samples          = 200;
  ConfigFile       = 'LEARN.INI';
  PopupTitleFore   = Magenta;

Type
  TInfoType = (itButton,itHat,itThrottle,itTwist,itAxis,itAnalog);
  TDigitalPacket = Object
    Bits: Array[0..MaxChannelLength - 1] Of Byte;
    Procedure Clear;
    Procedure _And(Var Source: TDigitalPacket);
    Procedure _Or(Var Source: TDigitalPacket);
    Procedure _Xor(Var Source: TDigitalPacket);
    Procedure _Not;
    Procedure Copy(Var Source: TDigitalPacket);
    Function  AsString: String;
    Procedure SetDef(Ch: Char; Var Source: TDigitalPacket);
    Function  Count: Integer;
    Function  Equal(Var Source: TDigitalPacket): Boolean;
  End;
  TXYPoint = Record
    X,Y: Integer;
  End;

Var
  MaxJoyCount    : LongInt;
  Packet         : TDigitalPacket;
  PacketDef      : TDigitalPacket;
  PacketNum      : TDigitalPacket;
  OldPacket      : TDigitalPacket;
  WorkPacket     : TDigitalPacket;
  WorkPacket1    : TDigitalPacket;
  WorkPacket2    : TDigitalPacket;
  DiffPacket     : TDigitalPacket;
  AnalogPacket   : TDigitalPacket;
  ThrottlePacket : TDigitalPacket;
  BtnPacket      : TDigitalPacket;
  HatPacket      : TDigitalPacket;
  AxisPacket     : TDigitalPacket;
  PacketSize     : Integer;
  _Win           : PWindow;
  F              : Text;
  NumThrottles   : Integer;
  St             : String;
  I,J            : Integer;

Function IntToStr(L: LongInt): String;
Var St: String;
Begin
  Str(L,St);
  IntToStr := St;
End; { IntToStr }

Function Trim(St: String): String;
Begin
  While (St <> '') And (St[1]          = ' ') Do St := Copy(St,2,Length(St) - 1);
  While (St <> '') And (St[Length(St)] = ' ') Do St := Copy(St,1,Length(St) - 1);
  Trim := St;
End; { Trim }

Function ToChar(I: Integer): Char;
Var Ch: Char;
Begin
  Case I Of
    0..9: Ch := Chr(I + Ord('0'));
  10..36: Ch := Chr(I + Ord('A') - 10);
  Else
    Ch := '0';
  End; { Case }
  ToChar := Ch;
End; { ToChar }

Procedure StayPopup(TitleTop,TitleBot,St: String);
Var I,J,X,Y : Integer;
Begin
  Screen.TextColor(Black);
  Screen.TextBackground(LightGray);
  I := Length(St);
  If Length(TitleTop) > I Then I := Length(TitleTop);
  If Length(TitleBot) > I Then I := Length(TitleBot);
  X := (MaxX Div 2) - ((I + 4) Div 2);
  Y := MaxY Div 2;
  _Win := New(PWindow,Init(X,Y - 2,X + I + 3,Y + 2,
            Black,LightGray,Black,LightGray,PopupTitleFore,LightGray,
            DoubleBorder,TitleTop,TitleBot,True));
  _Win^.Display;
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 2,Screen.TextAttr,St);
End; { StayPopup }

Procedure StayPopup4(TitleTop,TitleBot,St1,St2,St3,St4: String);
Var I,J,X,Y : Integer;
Begin
  Screen.TextColor(Black);
  Screen.TextBackground(LightGray);
  I := Length(St1);
  If Length(St2)      > I Then I := Length(St2);
  If Length(St3)      > I Then I := Length(St3);
  If Length(St4)      > I Then I := Length(St4);
  If Length(TitleTop) > I Then I := Length(TitleTop);
  If Length(TitleBot) > I Then I := Length(TitleBot);

  X := (MaxX Div 2) - ((I + 4) Div 2);
  Y := MaxY Div 2;
  _Win := New(PWindow,Init(X,Y - 2,X + I + 3,Y + 3,
            Black,LightGray,Black,LightGray,PopupTitleFore,LightGray,
            DoubleBorder,TitleTop,TitleBot,True));
  _Win^.Display;
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 1,Screen.TextAttr,St1);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 2,Screen.TextAttr,St2);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 3,Screen.TextAttr,St3);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 4,Screen.TextAttr,St4);
End; { StayPopup4 }

Procedure StayPopup12(TitleTop,TitleBot,
                       St1,St2,St3,St4,St5,St6,
                       St7,St8,St9,St10,St11,St12: String);
Var I,J,X,Y : Integer;
Begin
  Screen.TextColor(Black);
  Screen.TextBackground(LightGray);
  I := Length(St1);
  If Length(St2)      > I Then I := Length(St2);
  If Length(St3)      > I Then I := Length(St3);
  If Length(St4)      > I Then I := Length(St4);
  If Length(St5)      > I Then I := Length(St5);
  If Length(St6)      > I Then I := Length(St6);
  If Length(St7)      > I Then I := Length(St7);
  If Length(St8)      > I Then I := Length(St8);
  If Length(St9)      > I Then I := Length(St9);
  If Length(St10)     > I Then I := Length(St10);
  If Length(St11)     > I Then I := Length(St11);
  If Length(St12)     > I Then I := Length(St12);
  If Length(TitleTop) > I Then I := Length(TitleTop);
  If Length(TitleBot) > I Then I := Length(TitleBot);
  _Win := New(PWindow,InitWH(I + 4,14,
            Black,LightGray,Black,LightGray,PopupTitleFore,LightGray,
            DoubleBorder,TitleTop,TitleBot,True));
  _Win^.Display;
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 1, Screen.TextAttr,St1);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 2, Screen.TextAttr,St2);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 3, Screen.TextAttr,St3);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 4, Screen.TextAttr,St4);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 5, Screen.TextAttr,St5);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 6, Screen.TextAttr,St6);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 7, Screen.TextAttr,St7);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 8, Screen.TextAttr,St8);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 9, Screen.TextAttr,St9);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 10,Screen.TextAttr,St10);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 11,Screen.TextAttr,St11);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 12,Screen.TextAttr,St12);
End; { StayPopup12 }

Procedure TDigitalPacket.Clear;
Begin
  FillChar(Bits,SizeOf(Bits),#0);
End; { TDigitalPacket.Clear }

Procedure TDigitalPacket._And(Var Source: TDigitalPacket);
Var I: Integer;
Begin
  For I := 0 To PacketSize - 1 Do Bits[I] := Bits[I] And Source.Bits[I];
End; { TDigitalPacket._And }

Procedure TDigitalPacket._Or(Var Source: TDigitalPacket);
Var I: Integer;
Begin
  For I := 0 To PacketSize - 1 Do Bits[I] := Bits[I] Or Source.Bits[I];
End; { TDigitalPacket._Or }

Procedure TDigitalPacket._Xor(Var Source: TDigitalPacket);
Var I: Integer;
Begin
  For I := 0 To PacketSize - 1 Do Bits[I] := Bits[I] Xor Source.Bits[I];
End; { TDigitalPacket._Xor }

Procedure TDigitalPacket._Not;
Var I: Integer;
Begin
  For I := 0 To PacketSize - 1 Do Bits[I] := Bits[I] Xor 1;
End; { TDigitalPacket._Not }

Procedure TDigitalPacket.Copy(Var Source: TDigitalPacket);
Var I: Integer;
Begin
  Move(Source.Bits,Bits,SizeOf(Bits));
End; { TDigitalPacket.Copy }

Function TDigitalPacket.AsString: String;
Var
  St : String;
  I  : Integer;

Begin
  St := '';
  For I := 0 To PacketSize - 1 Do
  Begin
    Case Bits[I] Of
      0: St := St + '0';
      1: St := St + '1';
      32..255: St := St + Chr(Bits[I]);
    End; { Case }
  End; { For I }
  AsString := Trim(St);
End; { TDigitalPacket.AsString }

Procedure TDigitalPacket.SetDef(Ch: Char; Var Source: TDigitalPacket);
Var I: Integer;
Begin
  For I := 0 To PacketSize - 1 Do
   If Source.Bits[I] <> 0 Then Bits[I] := Ord(Ch);
End; { TDigitalPacket.SetDef }

Function TDigitalPacket.Count: Integer;
Var I,J: Integer;
Begin
  J := 0;
  For I := 0 To PacketSize - 1 Do If Bits[I] <> 0 Then Inc(J);
  Count := J;
End; { TDigitalPacket.Count }

Function TDigitalPacket.Equal(Var Source: TDigitalPacket): Boolean;
Var
  I : Integer;
  B : Boolean;

Begin
  B := True;
  I := 0;
  While (I < PacketSize) And B Do
  Begin
    If Bits[I] <> Source.Bits[I] Then B := False;
    Inc(I);
  End; { While }
  Equal := B;
End; { TDigitalPacket.Equal }

Procedure GetMaxJoyCount;
Const
  WaitTime = 300;  { 300 ms }
  ReadTime = 6;    { 6 ms   }

Var
  T1,T2     : LongInt; { Millisecond timers }
  Count     : LongInt; { Iteration count    }
  Both      : LongInt; { Iteration count    }
  ClockOnly : LongInt; { Time in ms         }
  JoyTime   : LongInt; { Time in ms         }

  Function RoundUp(E: Extended): LongInt;
  Begin
    If E < 0 Then
    Begin
      If Frac(E) <> 0 Then RoundUp := Trunc(E) - 1 Else RoundUp := Trunc(E);
    End
    Else
    Begin
      If Frac(E) <> 0 Then RoundUp := Trunc(E) + 1 Else RoundUp := Trunc(E);
    End;
  End; { RoundUp }

Label TimerLoop;
Begin
  MaxJoyCount := 0;

  { Find out how long it takes to read both the clock and the joystick }

  { The repeat loop is needed because Windows 98 sometimes makes time go }
  { backwards!  We need a good reading.                                  }

  Repeat
    T1 := Clock;

    { Reset the joystick port }

    Port[JoyPort] := 0;

    { Perform the loop }

    Asm
      DB     _32BIT_OPERAND  { Reset the counter }
      SUB    BX,BX
TimerLoop:
      IN     AL,DX           { Read and dummy test }
      TEST   AL,1            { Player 1 X coordinate }
      JZ     @L4
      DB     _32BIT_OPERAND  { Dummy increment }
      INC    AX
    @L4:
      DB     _32BIT_OPERAND  { The real increment }
      INC    BX

      DB     _32BIT_OPERAND  { Save registers }
      PUSH   BX
      PUSH   DX
    End; { Asm }
    T2 := Clock;
    Asm
      POP    DX              { Restore registers }
      DB     _32BIT_OPERAND
      POP    BX

      DB     _32BIT_OPERAND  { Check elapsed time }
      MOV    AX,WORD PTR T2
      DB     _32BIT_OPERAND
      SUB    AX,WORD PTR T1
      DB     _32BIT_OPERAND
      CMP    AX,WaitTime
      DW     0
      JB     TimerLoop
      DB     _32BIT_OPERAND
      MOV    WORD PTR Count,BX
    End; { Asm }
  Until T2 >= T1 + WaitTime;
  Both := Count;

  { Now find out how long it takes to do everything we did above except  }
  { read the joystick port                                               }

  { The repeat loop is needed because Windows 98 sometimes makes time go }
  { backwards!  We need a good reading.                                  }

  Repeat
    T1 := Clock;
    While Count > 0 Do
    Begin

      { Include what we did above }

      Asm
        DB     _32BIT_OPERAND  { Save registers }
        PUSH   BX
        PUSH   DX
      End; { Asm }

      T2 := Clock;

      Asm
        POP    DX              { Restore registers }
        DB     _32BIT_OPERAND
        POP    BX
        DB     _32BIT_OPERAND  { Check elapsed time }
        MOV    AX,WORD PTR T2
        DB     _32BIT_OPERAND
        SUB    AX,WORD PTR T1
        DB     _32BIT_OPERAND
        CMP    AX,WaitTime
        DW     0
        JB     @L1
        DB     _32BIT_OPERAND  { Do anythng here (likely won't be executed) }
        MOV    AX,WORD PTR T2
@L1:
      End; { Asm }

      Dec(Count);
    End; { While }
  Until T2 >= T1;
  ClockOnly := T2 - T1;

  { The time we spent actually reading the port is WaitTime - ClockOnly. }
  { Calculate the number of joystick read iterations that we can perform }
  { in 3 ms. If WaitTime - ClockOnly is zero, force it to one, but this  }
  { really should never happen.                                          }

  JoyTime := WaitTime - ClockOnly;
  If JoyTime <= 0 Then JoyTime := 1;

  MaxJoyCount := RoundUp(ReadTime * (Both / JoyTime));
End; { GetMaxJoyCount }

Function ReadSWPacket(Var Packet: TDigitalPacket): Integer;
Var
  Channel      : TDigitalPacket;
  Count        : LongInt;
  ChLen        : Word;
  I,J          : Integer;
  NewPacketLen : Integer;

  Procedure Expand1;
  Var I: Integer;
  Begin
    For I := 0 To ChLen - 1 Do Channel.Bits[I] := (Channel.Bits[I] And $20) Shr 5;
    NewPacketLen := ChLen;
  End; { Expand1 }

  Procedure Expand3;
  Var I: Integer;
  Begin
    For I := ChLen - 1 DownTo 0 Do
    Begin
      If (I * 3) + 2 < SizeOf(Channel) Then
      Begin

        { Flip bits }

        If (Channel.Bits[I] And $80) <> 0
         Then Channel.Bits[I * 3 + 2] := 0
         Else Channel.Bits[I * 3 + 2] := 1;
        If (Channel.Bits[I] And $40) <> 0
         Then Channel.Bits[I * 3 + 1] := 0
         Else Channel.Bits[I * 3 + 1] := 1;
        If (Channel.Bits[I] And $20) <> 0
         Then Channel.Bits[I * 3] := 0
         Else Channel.Bits[I * 3] := 1;
      End;
    End; { For I }
    NewPacketLen := ChLen * 3;
  End; { Expand3 }

  Procedure Expand;
  Var I,J: Integer;
  Begin

    { Determine if the packet used only one or all three bits }

    J := 0;
    For I := 1 To ChLen - 1 Do J := J Or (Channel.Bits[1] Xor Channel.Bits[I]);
    If (J And $C0) <> 0 Then Expand3 Else Expand1;
    If (J And $70) = 0 Then NewPacketLen := 0;
  End; { Expand }

Begin
  Count := MaxJoyCount;
  Channel.Clear;                         { Initialize with zeroes }

  Asm
@DoKick:
    MOV   DX,JoyPort                     { Reset the joystick port }
    MOV   AL,0FFh
    OUT   DX,AL
    IN    AL,DX                          { Read the initial value }

(*
    TEST  AL,01h                         { Invalid packet? }
    JZ    @GetOut
*)

    MOV   BL,AL                          { Save the initial value }
    DB    _32BIT_OPERAND                 { Set the time counter }
    MOV   CX,WORD PTR Count
    SUB   SI,SI                          { Packet pointer }

    { Wait for first falling edge on clock }

@ClockLoop:
    DB    _32BIT_OPERAND                 { Decrement the counter }
    DEC   CX
    JS    @GetOut                        { Exit if timeout }
    IN    AL,DX                          { Read a byte }
    MOV   BH,AL                          { Save it }
    XOR   AL,BL                          { See if anything has changed }
    TEST  AL,10h
    JZ    @ClockLoop
    TEST  BH,10h
    JNZ   @ClockLoop

    { Get data on rising edges }

@PacketLoop:
    DB    _32BIT_OPERAND                 { Decrement the counter }
    DEC   CX
    JS    @GetOut                        { Exit if timeout }
    IN    AL,DX                          { Read a byte }

    TEST  AL,1                           { End of packet if bit 0 goes low }
    JZ    @GetOut


    MOV   BH,AL                          { Save it }
    XOR   AL,BL                          { See if anything has changed }

    TEST  AL,10h
    JZ    @NextByte
    TEST  BH,10h
    JZ    @NextByte

    MOV   BYTE PTR Channel.Bits[SI],BH
    INC   SI
    CMP   SI,MaxChannelLength
    JAE   @GetOut

@NextByte:
    MOV   BL,BH                          { Save the byte that was read }
    JMP   @PacketLoop
@GetOut:
    DB    _32BIT_OPERAND                 { Save the final counter }
    MOV   WORD PTR Count,CX
    MOV   WORD PTR ChLen,SI
  End; { Asm }
  Delay(2);     { Need this! }



{
  Assign(F,'SW.LOG');
  ReWrite(F,1);
  BlockWrite(F,Channel,SizeOf(Channel));
  Close(F);
}
{
  Popup('ChLen:' + IntToStr(ChLen) + '  ' +
        'Count:' + IntToStr(Count));

  Screen.FastWrite(1,3,7,'ChLen:' + IntToStr(ChLen) + '  ' +
        'Count:' + IntToStr(Count));
}

  { Evaluate the packet }

  If ChLen < SizeOf(Channel) Then
  Begin
    Expand;
    J := 0;
    For I := 0 To MaxChannelLength - 1 Do If Channel.Bits[I] <> 0 Then Inc(J);
    If J = 0 Then NewPacketLen := 0;
    ReadSWPacket := NewPacketLen;
    Move(Channel,Packet,SizeOf(Packet));
  End
  Else ReadSWPacket := 0;
End; { ReadSWPacket }


Function ReadPacket(Var Packet: TDigitalPacket): Integer;
Begin
  ReadPacket := ReadSWPacket(Packet);
End; { ReadPacket }

Procedure GetPacketSize;
Var
  Size : Array[1..Samples] Of Integer;
  Num  : Array[0..255]     Of Integer;
  I,J  : Integer;

Begin
  FillChar(Size,SizeOf(Size),#0);
  FillChar(Num,SizeOf(Num),#0);
  I := 1;
  Port[JoyPort] := $FF;  { Reset the port and wait 1 full second to skip }
                         { the ID packet (I don't know how to parse it)  }
  Delay(1000);
  While (I < Samples) And Not KeyPressed Do
  Begin
    J := ReadPacket(Packet);
    Delay(50);
    If J > 0 Then
    Begin
      Size[I] := J;
      Inc(I);
    End;
  End; { While }
  If KeyPressed Then Halt
  Else
  Begin
    For J := 1 To I - 1 Do Inc(Num[Size[J]]);
    PacketSize := 0;
    J          := 0;
    For I := 0 To 255 Do If Num[I] > J Then PacketSize := I;
  End;
End; { GetPacketSize }

Procedure GatherAll;
Var Ch: Char;
Begin
  Repeat
  Until ReadPacket(OldPacket) = PacketSize;
  DiffPacket.Clear;
  Repeat
    If ReadPacket(Packet) = PacketSize Then
    Begin;
      Screen.FastWrite(1,MaxY,$17,Packet.AsString);
      WorkPacket.Copy(Packet);
      WorkPacket._Xor(OldPacket);
      DiffPacket._Or(WorkPacket);
      OldPacket.Copy(Packet);
{      Screen.FastWrite(1,MaxY - 1,$17,DiffPacket.AsString);}
    End;
  Until KeyPressed;
  While KeyPressed Do Ch := ReadKey;
  If Ch = #27 Then Halt;
End; { GatherAll }

Procedure FindAllAnalog;
Begin
  StayPopup12(' Establish all non-button functions ',' Step 1 ',
     'DO NOT PRESS ANY JOYSTICK BUTTONS OR MOVE ANY DIGITAL',
     'HATS OR DIGITAL DIRECTIONAL CONTROLS',
     '',
     'Slowly do the following:',
     '- Move ALL ANALOG joysticks to all extremes',
     '- Move all throttles to both extremes',
     '- Twist handle(s) to both extremes, if available',
     '- Press all ANALOG flippers',
     '- Move all ANALOG hats to all extremes',
     '- Tilt entire controller in all directions',
     '',
     'When finished press a key (hit Esc to exit)');
  GatherAll;
  Dispose(_Win,Done);
End; { FindAllAnalog }

Procedure FindAllDigitalHats;
Begin
  StayPopup12(' Establish all digital hat functions ',' Step 2 ',
     'Slowly do the following:',
     'DO NOT PRESS ANY JOYSTICK BUTTONS OR MOVE ANY DIGITAL',
     'DIRECTIONAL CONTROLS',
     '',
     '- Move all DIGITAL hats to all extremes',
     '',
     '',
     '',
     '',
     '',
     '',
     'When finished press a key (hit Esc to exit)');
  GatherAll;
  Dispose(_Win,Done);
End; { FindAllDigitalHats }

Procedure FindAllDigitalAxes;
Begin
  StayPopup12(' Establish all digital axis functions ',' Step 3 ',
     'Slowly do the following:',
     'DO NOT PRESS ANY JOYSTICK BUTTONS',
     '',
     '- Move all DIGITAL direction controllers to all extremes',
     '',
     '',
     '',
     '',
     '',
     '',
     '',
     'When finished press a key (hit Esc to exit)');
  GatherAll;
  Dispose(_Win,Done);
End; { FindAllDigitalAxes }

Procedure FindAllButtons;
Begin
  StayPopup12(' Establish all button functions ',' Step 4 ',
     'Slowly do the following:',
     '- Press and release all joystick buttons',
     '',
     '',
     '',
     '',
     '',
     '',
     '',
     '',
     '',
     'When finished press a key (hit Esc to exit)');
  GatherAll;
  Dispose(_Win,Done);
End; { FindAllButtons }

Procedure FindAllThrottles;
Var
  I  : Integer;
  Ok : Boolean;
  Ch : Char;

Begin
  StayPopup4(' Isolate throttle and analog flipper functions ',' Step 5 ',
     'How many throttles do you have?',
     '(include all analog flippers)',
     '',
     '');
  Repeat
    St := _BufLen(15,4,'',7,0,1,2);
    Val(St,NumThrottles,I);
  Until (NumThrottles >= 0) And (NumThrottles <= 9) And (I = 0);
  Dispose(_Win,Done);
  For I := 1 To NumThrottles Do
  Begin

    Repeat
      { Test with throttle/flipper at one extreme }

      StayPopup4(' Isolate throttle and analog flipper functions ',' Step 5a ',
       '',
       'Move/hold throttle/flipper ' + IntToStr(I) + ' to one extreme',
       'and hit a key (hit Esc to exit)',
       '');
      If ReadKey = #27 Then Halt;
      Dispose(_Win,Done);
      StayPopup12(' Isolate throttle and analog flipper functions ',' Step 5b ',
       'With throttle/flipper at extreme position,',
       'move all analog joysticks to all extremes and',
       'twist analog handle(s) to all extremes',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'When finished press a key (hit Esc to exit)');
      GatherAll;
      Dispose(_Win,Done);
      WorkPacket1.Copy(DiffPacket);
      WorkPacket1._And(AnalogPacket);

      { Test with throttle/flipper at the other extreme }

      StayPopup4(' Isolate throttle and analog flipper functions ',' Step 5c ',
       '',
       'Move/hold throttle/flipper ' + IntToStr(I) + ' to the other extreme',
       'and hit a key (hit Esc to exit)',
       '');
      If ReadKey = #27 Then Halt;
      Dispose(_Win,Done);
      StayPopup12(' Isolate throttle and analog flipper functions ',' Step 5d ',
       'With throttle/flipper at extreme position,',
       'move all analog joysticks to all extremes,',
       'twist analog handle(s) to all extremes,',
       'and move all other throttle/flippers to all',
       'extremes.',
       '',
       '',
       '',
       '',
       '',
       '',
       'When finished press a key (hit Esc to exit)');
      GatherAll;
      Dispose(_Win,Done);
      WorkPacket2.Copy(DiffPacket);
      WorkPacket2._And(AnalogPacket);

      WorkPacket.Copy(WorkPacket1);
      WorkPacket._And(WorkPacket2);

      If (Not WorkPacket1.Equal(WorkPacket2)) Or (WorkPacket1.Count = 0) Then
      Begin
        StayPopup4(' ERROR ','',
         'LEARN was unable to differentiate the throttle/flipper',
         'from the rest of the joystick.',
         '',
         '                  Try again? (Y/N)');
        Repeat
          Ch := UpCase(ReadKey);
        Until Ch In ['N','Y'];
        Dispose(_Win,Done);
        Ok := (Ch = 'N');
      End
      Else
      Begin
        Ok := True;
        WorkPacket._Not;
        ThrottlePacket.Copy(AnalogPacket);
        ThrottlePacket._And(WorkPacket);
        AnalogPacket._And(WorkPacket1);
        PacketDef.SetDef('T',ThrottlePacket);
        PacketDef.SetDef('A',AnalogPacket);
        PacketNum.SetDef(ToChar(I - 1),ThrottlePacket);
      End;
    Until Ok;
  End; { For I }
End; { FindAllThrottles }

Procedure Display;
Begin
  Screen.TextColor(LightGray);
  Screen.Textbackground(Blue);
  Screen.GotoXY(1,1);
  Screen.Write('Packet size: ' + IntToStr(PacketSize));
  Screen.GotoXY(1,3);
  Screen.WriteLn('Def:' + PacketDef.AsString);
  Screen.WriteLn('Num:' + PacketNum.AsString);
End; { Display }

Begin
  Screen.TextColor(LightGray);
  Screen.TextBackground(Blue);
  Screen.ClrScr;

  StayPopup(' SideWinder Learn Program ','','Detecting packet size...');

  GetMaxJoyCount;
  GetPacketSize;
  Dispose(_Win,Done);
  Display;
  PacketDef.Clear;
  PacketNum.Clear;

  FindAllAnalog;                   { Locate all analog functions }
  AnalogPacket.Copy(DiffPacket);
  PacketDef.SetDef('a',AnalogPacket);
  Display;

  FindAllDigitalHats;              { Isolate all digital hat functions }
  HatPacket.Copy(DiffPacket);
  Packet.Copy(AnalogPacket);
  Packet._Not;
  HatPacket._And(Packet);
  PacketDef.SetDef('H',HatPacket);
  Display;

  FindAllDigitalAxes;              { Isolate all digital axis functions }
  AxisPacket.Copy(DiffPacket);
  Packet.Copy(AnalogPacket);
  Packet._Not;
  AxisPacket._And(Packet);
  PacketDef.SetDef('X',AxisPacket);
  Display;

  FindAllButtons;                  { Isolate all button functions }
  BtnPacket.Copy(DiffPacket);
  Packet.Copy(AnalogPacket);
  Packet._Not;
  BtnPacket._And(Packet);
  PacketDef.SetDef('B',BtnPacket);
  J := 0;
  For I := 0 To PacketSize - 1 Do
  Begin
    If Chr(PacketDef.Bits[I]) = 'B' Then
    Begin
      PacketNum.Bits[I] := Ord(ToChar(J));
      Inc(J);
    End;
  End; { For I }
  Display;

  FindAllThrottles;                { Isolate all throttle functions }
  Display;

  Assign(F,ConfigFile);
  ReWrite(F);
  WriteLn(F,'; LEARN.INI - Detected Microsoft packet information');
  WriteLn(F);
  WriteLn(F,'; Legend: (def)');
  WriteLn(F,';         B - button');
  WriteLn(F,';         X - digital axis');
  WriteLn(F,';         H - digital hat');
  WriteLn(F,';         T - analog throttle/flipper');
  WriteLn(F,';         A - analog axis');
  WriteLn(F,';         0 - always 0');
  WriteLn(F,';         1 - always 1');
  WriteLn(F);
  WriteLn(F,'; Notes');
  WriteLn(F,';         1. Some digital hats are really digital axes and vice versa.');
  WriteLn(F);
  WriteLn(F,'[CONFIG]');
  WriteLn(F,'DEF=' + PacketDef.AsString);
  WriteLn(F,'NUM=' + PacketNum.AsString);
  Close(F);

  StayPopup12(' Saving configuration ',' Final step ',
     '',
     '',
     'Writing configuration to LEARN.INI',
     '',
     '',
     'Hit a key to exit',
     '',
     '',
     '',
     '',
     '',
     '');
  ReadKey;
  Dispose(_Win,Done);
End.
